Angular: création d'un pipe
===========================
![category](développement)
![tag](angular)
Un pipe est un objet qui permet de traiter de façon dynamique un objet dans la partie
html de notre code.

Il existe de nombreux pipes "classique"

```
<p>The hero's birthday is {{ birthday | date:"MM/dd/yy" }} </p>
The chained hero's birthday is {{  birthday | date:'fullDate' | uppercase}}
{{ test | json }}

```

là ou cela devient interessant est qu'on peut créer notre propre pipe.

Voilà un exemple concret: à partir d'un texte contenant plusieurs lignes je souhaite
faire un extract en ne premenant que les n premiers caractères de la première ligne.

generation de mon pipe

```
ng generate pipe Truncate-Text
```

et après modification de fichier truncate-text.pipe.ts 

```js
import { Pipe, PipeTransform } from '@angular/core';

@Pipe({
name: 'truncateText'
})
export class TruncateTextPipe implements PipeTransform {

    transform(value: string, length: number, elipses: string='...'): string {
        if(typeof value === "undefined") return value;
        if(value.indexOf("\n") > -1){
            value = value.slice(0, value.indexOf("\n"));
        };
        if(value.length <= length) return value;
    
        let truncatedText = value.slice(0, length);
        if(truncatedText.lastIndexOf(" ") > -1){
            truncatedText = truncatedText.slice(0, truncatedText.lastIndexOf(" "))
        }
        return truncatedText + elipses; 
    }

}
```

```note
on peut placer autant de variable que l'on souhaite
perso je rajoute toujours une valeur par défaut ... cela évite les erreurs de compilation
```

on peut alors l'utiliser ainsi

```html
{{ todo.summary  | truncateText:50 }}
{{ todo.summary  | truncateText:40:--- }}